'GSMGSD
'	PROGRAM TO APPLY A FILTER TO AN INPUT GSMAP DATA BASE
'	AND WRITE OUT A GSMAP DATA BASE.  THE FILTER IS THE
'	DOUGLAS-PEUCKER ALGORITHM.  THE OUTPUT DATA LINES ARE
'	FILTERED TO REMOVE POINTS THAT ARE UNNECESSARY AT THE 
'	NEW SCALE.
'
DEFDBL A-Z
OPTION BASE 1
COMMON SHARED /FILE2/ IREC$
COMMON SHARED /FILE3/ LREC$
COMMON SHARED /FILE4/ DIREC$
COMMON SHARED /FILE5/ DLREC$
KEY OFF
' $DYNAMIC
DIM SHARED XD(8000),YD(8000),XPI(8000),YPI(8000)
DIM SHARED GEOG(2),PROJ(2),DARRAY(9)
DIM SHARED DBWLL(4,2)
FUNCTION DBLMIN(A,B) STATIC
	DBLMIN=-B*(B<A)-A*(A<B)-A*(A=B)
END FUNCTION
FUNCTION DBLMAX(A,B) STATIC
	DBLMAX=-B*(B>A)-A*(A>B)-A*(A=B)
END FUNCTION
' $STATIC
	WIDTH 80
	CLS
	LOCATE  4,29:PRINT "   G  S  M  F  I  L"
	LOCATE  6,29:PRINT "    Version 1.0"
	LOCATE  8,29:PRINT " Open File 88-665B"
	LOCATE 11,22:PRINT "Gary I. Selner and Richard B. Taylor"
	LOCATE 12,29:PRINT "U. S. Geological Survey"
	LOCATE 15,29:PRINT "     DISCLAIMER          "
	LOCATE 17,10:PRINT "Although program tests have been made, no guarantee (expressed";
	LOCATE 18,10:PRINT "or implied) is made by the author regarding program correctness,";
	LOCATE 19,10:PRINT "accuracy, or proper execution on all computer systems.";
	SLEEP(1)
	CLS
	INPUT "ENTER GSMAP INPUT DATA BASE: ",MFILNAM$
	IFILNAM$=MFILNAM$+".NDX"
	LFILNAM$=MFILNAM$+".LSF"
	INPUT "ENTER GSMAP OUTPUT DATA BASE: ",DFILNAM$
'go setup latitude-longitude to xy projection parameters
DPR1:	ECODE%=0
	INPUT "ENTER FILENAME OF PROJECTION PARAMETERS: ",SFILNAM$
	ON ERROR GOTO 8750
	OPEN SFILNAM$ FOR INPUT AS #5
	ON ERROR GOTO 0
	IF ECODE%=1 THEN GOTO DPR1
	CALL SetupProjection(PTYP%,DARRAY(),CM)
	INPUT "ENTER TOLERANCE: ",TOL
	TOLSQ=TOL*TOL
	ZONE%=0
	OPEN "R", #2, IFILNAM$,20
	FIELD #2, 20 AS IREC$
	OPEN "R",#3, LFILNAM$, 16
	FIELD #3,16 AS LREC$
	CALL ReadFirst(ILINE!,ISTART!,IEND!,TITLE$,DBWLL())
	IFILNAM$=DFILNAM$+".NDX"
	LFILNAM$=DFILNAM$+".LSF"
	OPEN "R", #4, IFILNAM$,20
	FIELD #4, 20 AS DIREC$
	OPEN "R",#5, LFILNAM$, 16
	FIELD #5,16 AS DLREC$
	DLINE!=0
	DSTART!=5
	DEND!=5
	LOCATE 24,1
680	INPUT "ENTER CODE TO BE SELECTED(-1=ALL, 0=EXIT): ",ILC!
	IF ILC!<>0 THEN
		FOR I!=1 TO ILINE!
			ID!=I!
			CALL ReadId(ID!,ISTARTI!,IENDI!,LCODE!,VAL1!,VAL2!,ICNT%)
			IF ILC!=-1 OR ILC!=LCODE! THEN
				IF (ISTARTI! > 0 AND IENDI! > 0) THEN
					JOB%=1
					ICNT%=0
					FOR J!=ISTARTI! TO IENDI!
						II!=J!
						CALL ReadDataRecords(II!,LAT,LON)
						ICNT%=ICNT%+1
						XD(ICNT%)=LAT
						YD(ICNT%)=LON
					NEXT J!
					IF (LCODE!>=1 AND LCODE!<=99) THEN
						FOR I%=1 TO ICNT%
							GEOG(1)=YD(I%)
							GEOG(2)=XD(I%)
							CALL PROJECT(GEOG(),PROJ(),ZONE%,PTYP%,JOB%,DARRAY())
							XD(I%)=PROJ(1)*1000.D0
							YD(I%)=PROJ(2)*1000.D0
						NEXT I%
						CALL DPFILT(XD(),YD(),ICNT%,TOLSQ)
						JOB%=2
						FOR I%=1 TO ICNT%
							PROJ(1)=XD(I%)/1000.0
							PROJ(2)=YD(I%)/1000.0
							CALL PROJECT(GEOG(),PROJ(),ZONE%,PTYP%,JOB%,DARRAY())
							XD(I%)=GEOG(2)
							YD(I%)=GEOG(1)
						NEXT I%
					END IF
					IF (LCODE!>=400 AND LCODE!<=499) THEN
						FOR I%=1 TO ICNT%
							GEOG(1)=YD(I%)
							GEOG(2)=XD(I%)
							CALL PROJECT(GEOG(),PROJ(),ZONE%,PTYP%,JOB%,DARRAY())
							XD(I%)=PROJ(1)*1000.D0
							YD(I%)=PROJ(2)*1000.D0
						NEXT I%
						JCNT%=0
						KCNT%=1
700						XSAV=XD(KCNT%)
						YSAV=YD(KCNT%)
						FOR I%=KCNT%+1 TO ICNT%
							IF XD(I%)=XSAV AND YD(I%)=YSAV THEN
								LCNT%=I%
								GOTO 705
							END IF
						NEXT I%
						LCNT%=ICNT%
705						CNT%=0
						FOR I%=KCNT% TO LCNT%
							CNT%=CNT%+1
							XPI(CNT%)=XD(I%)
							YPI(CNT%)=YD(I%)
						NEXT I%
						CALL DPFILT(XPI(),YPI(),CNT%,TOLSQ)
						FOR I%=1 TO CNT%
							XD(JCNT%+I%)=XPI(I%)
							YD(JCNT%+I%)=YPI(I%)
						NEXT I%
						JCNT%=JCNT%+CNT%
						KCNT%=LCNT%+1
						IF KCNT%<ICNT% GOTO 700
						ICNT%=JCNT%
						JOB%=2
						FOR I%=1 TO ICNT%
							PROJ(1)=XD(I%)/1000.0
							PROJ(2)=YD(I%)/1000.0
							CALL PROJECT(GEOG(),PROJ(),ZONE%,PTYP%,JOB%,DARRAY())
							XD(I%)=GEOG(2)
							YD(I%)=GEOG(1)
						NEXT I%
					END IF
					DLINE!=DLINE!+1
					DSTARTI!=DEND!+1
					DENDI!=DEND!+ICNT%
					JOB%=2
					II!=DSTARTI!
					FOR J!=1 TO ICNT%
						LAT=XD(J!)
						LON=YD(J!)
						CALL WriteDataRecords(II!,LAT,LON)
						II!=II!+1
					NEXT J!
					ID!=DLINE!
					CALL WriteId(ID!,DSTARTI!,DENDI!,LCODE!,VAL1!,VAL2!)
					DEND!=DEND!+ICNT%
				END IF
			END IF
			LOCATE 25,1:PRINT I!;
		NEXT I!
		PRINT
		IF ILC!<>-1 GOTO 680
	END IF
1050	OPT%=0
	CALL WriteFirst(DLINE!,DSTART!,DEND!,OPT%,TITLE$,DBWLL())
	CLOSE #2,#3,#4,#5
END
'ERROR ROUTINE FOR OPENING PROJECTION PARAMETERS FILE
8750	PRINT "AN ERROR HAS OCCURRED OPENING PROJECTION PARAMETERS FILE"
	PRINT "RETURNING TO ALLOW RE-ENTRY."
	ECODE%=1
	RESUME NEXT
SUB ReadFirst(ILINE!,ISTART!,IEND!,TITLE$,DBWLL(2)) STATIC
	GET#2,1
	ILINE!=CVS(MID$(IREC$,1,4))
	ISTART!=ABS(CVS(MID$(IREC$,5,4)))
	IEND!=ABS(CVS(MID$(IREC$,9,4)))
	GET#3,1
	TITLE$=MID$(LREC$,1,16)
	FOR IJK%=1 TO 4
		IR!=IJK%+1
		GET#3,IR!
		DBWLL(IJK%,1)=CVD(MID$(LREC$,1,8))
		DBWLL(IJK%,2)=CVD(MID$(LREC$,9,8))
	NEXT IJK%
END SUB
SUB ReadId(ID!,ISTARTI!,IENDI!,LCODE!,VAL1!,VAL2!,ICNT%) STATIC
	IR!=ID!+1
	GET #2,IR!
	ISTARTI!=CVS(MID$(IREC$,1,4))
	IENDI!=CVS(MID$(IREC$,5,4))
	LCODE!=CVS(MID$(IREC$,9,4))
	VAL1!=CVS(MID$(IREC$,13,4))
	VAL2!=CVS(MID$(IREC$,17,4))
	ICNT%=IENDI!-ISTARTI!+1
	IF ICNT%>8000 THEN
		IENDI!=ISTARTI!+7999
		ICNT%=8000
	END IF
END SUB
SUB ReadDataRecords(II!,LAT,LON) STATIC
	GET #3,II!
	LAT=CVD(MID$(LREC$,1,8))
	LON=CVD(MID$(LREC$,9,8))
END SUB
SUB WriteFirst(ILINE!,ISTART!,IEND!,OPT%,TITLE$,DBWLL(2)) STATIC
	MID$(DIREC$,1,4)=MKS$(ILINE!)
	MID$(DIREC$,5,4)=MKS$(ISTART!)
	MID$(DIREC$,9,4)=MKS$(IEND!)
	LSET DIREC$=DIREC$
	PUT#4,1
	IF OPT%=0 THEN
		MID$(DLREC$,1,16)=TITLE$
		LSET DLREC$=DLREC$
		PUT #5,1
		FOR IJK%=1 TO 4
			MID$(DLREC$,1,8)=MKD$(DBWLL(IJK%,1))
			MID$(DLREC$,9,8)=MKD$(DBWLL(IJK%,2))
			LSET DLREC$=DLREC$
			IR!=IJK%+1
			PUT#5,IR!
		NEXT IJK%
	END IF
END SUB
SUB WriteId(ID!,ISTARTI!,IENDI!,LCODE!,VAL1!,VAL2!) STATIC
	II!=ID!+1
	MID$(DIREC$,1,4)=MKS$(ISTARTI!)
	MID$(DIREC$,5,4)=MKS$(IENDI!)
	MID$(DIREC$,9,4)=MKS$(LCODE!)
	MID$(DIREC$,13,4)=MKS$(VAL1!)
	MID$(DIREC$,17,4)=MKS$(VAL2!)
	LSET DIREC$=DIREC$
	PUT#4,II!
END SUB
SUB WriteDataRecords(II!,LAT,LON) STATIC
	MID$(DLREC$,1,8)=MKD$(LAT)
	MID$(DLREC$,9,8)=MKD$(LON)
	LSET DLREC$=DLREC$
	PUT #5,II!
END SUB
FUNCTION DISTSQ(X#(1),Y#(1),NPTS%,PN%()) STATIC
'
'*******************************************************************
'
'   THIS ROUTINE DETERMINES THE ABSOLUTE SQUARE DISTANCE FROM THE
'   POINT P1:(X1,Y1) TO THE LINE DETERMINED BY THE TWO POINTS
'   P2:(X2,Y2) AND P3:(X3,Y3)
'
'*******************************************************************
'
'   PARAMETERS:  LINE - ARRAY WHICH CONTAINS POINTS FOR THE
'                       GIVEN FEATURE
'                NPTS-NUMBER OF POINTS IN LINE
'                PN - ARRAY WHICH CONTAINS THE POINT NUMBERS
'                     FOR POINTS P1, P2, AND P3
'
'   VARIABLES:  A - COEFFICIENT OF X TERM IN THE LINE EQUATION
'                   A*X + B*Y = D
'               ADEN - DENOMINATOR
'               ANUM - NUMERATOR
'               B - COEFFICIENT OF Y TERM IN THE LINE EQUATION
'                   A*X + B*Y = D
'               D - CONSTANT TERM IN THE LINE EQUATION
'                   A*X + B*Y = D
'               X1 - REAL X COORDINATE FOR POINT P1
'               X2 - REAL X COORDINATE FOR POINT P2
'               X3 - REAL X COORDINATE FOR POINT P3
'               Y1 - REAL Y COORDINATE FOR POINT P1
'               Y2 - REAL Y COORDINATE FOR POINT P2
'               Y3 - REAL Y COORDINATE FOR POINT P3
'
'*******************************************************************
'
'   CALLED BY:
'
'   CALLS:  ***
'
'*******************************************************************
'
'            CONVERT TO FLOATING POINT
'
      X1 = X#(PN%(1))
      Y1 = Y#(PN%(1))
      X2 = X#(PN%(2))
      Y2 = Y#(PN%(2))
      X3 = X#(PN%(3))
      Y3 = Y#(PN%(3))
'
'            P2 AND P3 ARE COINCIDENT
'
	IF (X2=X3) AND (Y2=Y3) THEN
		DISTSQ = (((X1-X2)^2)+((Y1-Y2)^2))
	ELSE
'
'            LINE IS PARALLEL TO X-AXIS
'
		IF(Y2=Y3) THEN
			DISTSQ = (Y1-Y2)^2
'
'            LINE IS PARALLEL TO Y-AXIS
'
		ELSEIF (X2=X3) THEN
			DISTSQ = (X1-X2)^2
'
'            LINE IS NOT PARALLEL TO EITHER AXIS
'
		ELSE
			A = Y2 - Y3
			B = X3 - X2
			D = X3*Y2 - X2*Y3
			ANUM = ((A*X1)+(B*Y1)-D)^2
			ADEN = ((A^2)+(B^2))
			DISTSQ = ANUM / ADEN
		END IF
	END IF
END FUNCTION
SUB DPFILT(X#(1),Y#(1),NPTS%,TOLSQ) STATIC
'
' **********************************************************************
' *                                                                    *
' * DPFILT - DOUGLAS-PEUCKER FILTER                                    *
' *                                                                    *
' *      THIS PROCEDURE IS AN IMPLEMENTATION OF THE DOUGLAS-PEUCKER    *
' * ALGORITHM FOR LINE GENERALIZATION (SEE 'ALGORITHMS FOR THE REDUC-  *
' * TION OF THE NUMBER OF POINTS REQUIRED TO REPRESENT A DIGITIZED     *
' * LINE OR ITS CARICATURE', BY D.H. DOUGLAS AND T.K. PEUCKER,         *
' * CANADIAN CARTOGRAPHER, VOL. 10, NO. 2, DEC. 1973, PP. 112-122.     *
' *                                                                    *
' *      THIS ALGORITHM SELECTS THE POINT IN THE LINE WITH THE GREATEST*
' * PERPEDICULAR DISTANCE FROM A MATHEMATICAL LINE BETWEEN THE ANCHOR  *
' * (1ST POINT) AND THE FLOATER (LAST POINT). TWO LINES ARE FORMED,    *
' * ONE CONSISTING OF THE POINTS BEFORE THE POINT WITH THE GREATEST    *
' * PERPENDICULAR DISTANCE AND ONE CONSISTING OF THE POINT AFTER. EACH *
' * OF THESE LINES IS EXACTLY AS THE ORIGINAL LINE WAS, EACH POSSIBLY  *
' * FORMING 2 MORE LINES. THE PROCEDURE CONTINUES UNTIL ALL POINTS     *
' * BETWEEN THE ANCHOR AND FLOATER ARE WITHIN A PRESET TOLERANCE FOR   *
' * EACH LINE PART. THE GENERALIZED LINE THEN CONSISTS OF ALL ANCHOR   *
' * AND FLOATER POINTS.                                                *
' *                                                                    *
' *      THIS IMPLEMENTATION OF THE ALGORITHM USES A STACK TO HOLD THE *
' * INDICES OF THE ANCHOR AND FLOATER POINTS, PERFORMING DISTANCE      *
' * CHECKS AS INDICES ARE PUSHED AND POPPED FROM THE STACK. WHEN THE   *
' * STACK IS EMPTY ALL POINTS WILL THEN HAVE BEEN FOUND TO FORM THE    *
' * GENERALIZED LINE. AS EACH INDEX IS POPPED FROM THE STACK IT IS     *
' * STORED IN AN ARRAY. THIS ARRAY OF INDICES IS USED TO FORM THE      *
' * GENERALIZED LINE.                                                  *
' *                                                                    *
' * DATA DICTIONARY                                                    *
' *                                                                    *
' *  ANCHOR - CURRENT ANCHOR POINT IN THE LINE                         *
' *  CNT - NUMBER OF POINTS IN THE FILTERED LINE                       *
' *  FLOATR - CURRENT FLOATER POINT IN THE LINE                        *
' *  INDEX - NUMBER OF POINT FARTHEST FROM LINE BETWEEN ANCHOR         *
' *          AND FLOATER                                               *
' *  LINE - ARRAY THAT CONTAINS THE POINT IN THE LINE                  *
' *  LNINDX - ARRAY OF POINTERS TO THE POINTS THAT WILL REMAIN IN      *
' *           IN THE LINE                                              *
' *  NPTS - NUMBER OF POINTS IN THE INPUT LINE                         *
' *  PTCNT - INDEX FOR MOVING POINTS IN THE LINE                       *
' *  SQDIST - SQUARED DISTANCE OF THE POINT FROM THE LINE              *
' *  TOLSQ - FILTER TOLERANCE SQUARED                                  *
' *                                                                    *
' * ROUTINES CALLED:                                                   *
' *                                                                    *
' *  DSTCHK - CHECKS FOR POINT THAT IS THE MAXIMUM DISTANCE FROM       *
' *           THE LINE FORMED BETWEEN ANCHOR AND FLOATR                *
' *  MAXDST - FINDS POINT WHICH IS THE MAXIMUM DISTANCE FROM ANCHOR    *
' *  POP - REMOVES AN ELEMENT FROM THE STACK                           *
' *  PUSH - ADDS AN ELEMENT TO THE STACK                               *
' *  STKINT - INITIALIZES THE STACK ROUTINE                            *
' *  TOP - RETRIEVES TOP ELEMENT FROM STACK BUT DOES NOT REMOVE IT     *
' *                                                                    *
' **********************************************************************
'
'
' $DYNAMIC 
DIM STACK%(8000),LNINDX%(8000)
' $STATIC
	IF NPTS%>2 THEN
'
' INITIALIZE VARIABLES
'
		CNT% = 1
		ANCHOR% = 1
		FLOATR% = NPTS%
		SQDIST = 0.0
		INDEX% = NPTS%
		LNINDX%(CNT%) = 1
		CALL STKINT(STACK%(),STKTOP%)
'
		CALL PUSH(STACK%(),STKTOP%,FLOATR%)
'
' CHECK FOR CASE OF CLOSED LOOP
'
		IF (X#(1)<>X#(NPTS%)) OR (Y#(1)<>Y#(NPTS%)) THEN
			CALL MAXDST(X#(),Y#(),NPTS%,INDEX%)
			FLOATR% = INDEX%
			CALL PUSH(STACK%(),STKTOP%,FLOATR%)
		END IF
  100		CALL DSTCHK(X#(),Y#(),NPTS%,ANCHOR%,FLOATR%,INDEX%,SQDIST)
		IF SQDIST >= TOLSQ THEN
			FLOATR% = INDEX%
			CALL PUSH(STACK%(),STKTOP%,FLOATR%)
'
'                              CASE WHERE NO INTERVENING POINTS BETWEEN
'                             ANCHOR AND FLOATER. POP STACK TO GET NEW
'                             ANCHOR AND ASSIGN TO NEW LINE INDEX ARRAY
'
  200			IF ((FLOATR%-ANCHOR%) <= 1) THEN
				CALL POP(STACK%(),STKTOP%,ANCHOR%)
				CNT% = CNT% + 1
				LNINDX%(CNT%) = ANCHOR%
				CALL EMPTY(STACK%(),STKTOP%,STKEMP$)
				IF (STKEMP$="Y") GOTO 250
				CALL TOP(STACK%(),STKTOP%,FLOATR%)
				GOTO 200
			ELSE
				GOTO 100
			END IF
		ELSE
'
'                               SQDIST < TOLSQ THUS POP NEW ANCHOR POINT
'                             FROM STACK AND ASSIGN TO OUTPUT ARRAY
'
			CALL POP(STACK%(),STKTOP%,ANCHOR%)
			CNT% = CNT% + 1
			LNINDX%(CNT%) = ANCHOR%
			CALL EMPTY(STACK%(),STKTOP%,STKEMP$)
			IF (STKEMP$="Y") GOTO 250
			CALL TOP(STACK%(),STKTOP%,FLOATR%)
			GOTO 100
		END IF
'
' COPY POINTS INDEXED TO FORM FILTERED LINE
'
250		FOR PTCNT%=1 TO CNT%
			X#(PTCNT%)=X#(LNINDX%(PTCNT%))
			Y#(PTCNT%)=Y#(LNINDX%(PTCNT%))
		NEXT PTCNT%
		NPTS% = CNT%
	END IF
ERASE STACK%,LNINDX%
END SUB
SUB  MAXDST(X#(1),Y#(1),NPTS%,INDEX%) STATIC
'
' **********************************************************************
' *                                                                    *
' * MAXDST - MAXIMUM DISTANCE                                          *
' *                                                                    *
' *      THIS PROCEDURE COMPUTES THE DISTANCE BETWEEN THE FIRST POINT  *
' * IN THE LINE AND ALL OTHER POINTS. THE INDEX OF POINT AT THE        *
' * GREATEST DISTANCE FROM THE FIRST POINT IS HELD AND RETURNED.       *
' *                                                                    *
' **********************************************************************
'
      LSTDST = 0
'
' CALCULATE MAXIMUM DISTANCE
'
	FOR PTCNT%=2 TO NPTS%-1
		SQDIST= (X#(1)-X#(PTCNT%))^2 + (Y#(1)-Y#(PTCNT%))^2
	        IF (SQDIST > LSTDST) THEN
			LSTDST = SQDIST
			INDEX% = PTCNT%
		END IF
	NEXT PTCNT%
END SUB
'
' **********************************************************************
' *                                                                    *
' * STKINT -                                                           *
' *                                                                    *
' *     THIS ROUTINE IS AN IMPLEMENTATION OF A STACK. THERE ARE ENTRIES*
' * TO PERFORM THE STANDARD FUNCTIONS OF PUSH,POP,TOP, AND EMPTY.      *
' * FOR MORE INFORMATION ON A STACK AND ITS FUNCTIONS SEE A DATA       *
' * STRUCTURES TEXT.                                                   *
' *      THIS ENTRY IS USED TO INITIALIZE THE STACK BY SETTING THE     *
' * TOP POINTER TO ZERO AND INITIALIZING THE ARRAY                     *
' *                                                                    *
' * DATA DICTIONARY                                                    *
' *                                                                    *
' *  ELEM - ELEMENT TO BE ADDED OR REMOVED FROM THE STACK              *
' *  EMP - INDICATES THAT THE STACK IS EMPTY                           *
' *  STACK - ARRAY USED TO HOLD DATA IN STACK                          *
' *  STKTOP - POINTER TO THE TOP ELEMENT OF THE STACK                  *
' *                                                                    *
' * ROUTINES CALLED:                                                   *
' *                                                                    *
' *  ERRLOG - RECORDS ERRORS ENCOUNTERED IN PROGRAM                    *
' *                                                                    *
' **********************************************************************
'
SUB STKINT(STACK%(1),STKTOP%) STATIC
	STKTOP% = 0
	FOR NFILL%=1 TO 8000
		STACK%(NFILL%) = 0
	NEXT NFILL%
END SUB
SUB PUSH(STACK%(1),STKTOP%,ELEM%) STATIC
'
' **********************************************************************
' *                                                                    *
' * PUSH                                                               *
' *                                                                    *
' *      THIS ENTRY PUSHES AN ELEMENT ONTO THE STACK. THIS IS AC-      *
' * COMPLISHED BY INCREMENTING THE POINTER TO THE STACK AND ADDING     *
' * THE NEW ELEMENT TO THAT POSITION IN THE ARRAY. IF THE POINTER      *
' * EXCEEDS 5000 THEN A STACK OVERFLOW HAS OCCURED.                    *
' *                                                                    *
' **********************************************************************
'
	IF STKTOP% >= 8000 THEN
		PRINT "****** INTERNAL ERROR THE STACK HAS OVERFLOWED "
	ELSE
		STKTOP% = STKTOP% + 1
		STACK%(STKTOP%) = ELEM%
	END IF
END SUB
SUB POP(STACK%(1),STKTOP%,ELEM%) STATIC
'
' **********************************************************************
' *                                                                    *
' * POP                                                                *
' *                                                                    *
' *      THIS ROUTINE REMOVES THE TOP ELEMENT FROM THE STACK AND       *
' * RETURNS IT. THIS IS DONE BY ASSIGNING THE TOP ELEMENT TO THE       *
' * VARIABLE SPECIFIED AND DECREMENTING THE STACK POINTER BY ONE       *
' * IF THE STACK POINTER IS LESS THAN 1 THEN A STACK UNDERFLOW HAS     *
' * OCCURED.                                                           *
' *                                                                    *
' **********************************************************************
'
	IF STKTOP% < 1 THEN
		PRINT " **** INTERNAL ERROR - THE STACK HAS UNDERFLOWED "
	ELSE
		ELEM% = STACK%(STKTOP%)
		STKTOP% = STKTOP% - 1
	END IF
END SUB
SUB TOP(STACK%(1),STKTOP%,ELEM%) STATIC
' **********************************************************************
' *                                                                    *
' * TOP                                                                *
' *                                                                    *
' *      THIS ENTRY RETRIEVES THE TOP ELEMENT OF THE STACK WITHOUT     *
' * REMOVING IT. THE STACK POINTER IS LEFT UNCHANGED BY THIS ENTRY     *
' * IF THE STACK POINTER IS LESS THAN 1 THEN A STACK UNDERFLOW HAS     *
' * OCCURED.                                                           *
' *                                                                    *
' **********************************************************************
'
	IF STKTOP% < 1 THEN
		PRINT " **** INTERNAL ERROR - STACK UNDERFLOW"
	ELSE
'
		ELEM% = STACK%(STKTOP%)
	END IF
END SUB
SUB EMPTY(STACK%(1),STKTOP%,EMP$)
'
' **********************************************************************
' *                                                                    *
' * EMPTY                                                              *
' *                                                                    *
' *      THIS ENTRY CHECKS THE STACK TO SEE IF IT IS EMPTY. IF THE     *
' * STACK POINTER IS LESS THAN 1 THEN THE STACK IS EMPTY, OTHERWISE    *
' * IT IS NOT.                                                         *
' *                                                                    *
' **********************************************************************
'
	EMP$="N"
	IF STKTOP% <= 0 THEN
		EMP$="Y"
	END IF
END SUB
SUB DSTCHK(X#(1),Y#(1),NPTS%,ANCHOR%,FLOATR%,INDEX%,SQDIST) STATIC
'
' **********************************************************************
' *                                                                    *
' * DSTCHK - DISTANCE CHECK                                            *
' *                                                                    *
' *      THIS PROCEDURE COMPUTES THE SQUARE OF THE DISTANCE FROM THE   *
' * LINE FORMED BY THE ANCHOR POINT AND THE FLOATER POINT PERPENDICULAR*
' * TO EACH POINT IN THE LINE. THE INDEX OF THE POINT WITH THE MAXIMUM *
' * DISTANCE IS RETURNED TO THE CALLING PROCEDURE AS IS THE VALUE OF   *
' * THE MAXIMUM DISTANCE                                               *
' *                                                                    *
' * DATA DICTIONARY                                                    *
' *                                                                    *
' *  ANCHOR - POINTER TO ANCHOR POINT IN THE LINE                      *
' *  FLOATR - POINTER TO FLOATER POINT IN THE LINE                     *
' *  INDEX - POINTER TO POINT THAT IS THE MAXIMUM DISTANCE FROM        *
' *          THE LINE FORMED BETWEEN ANCHOR AND FLOATR                 *
' *  X,Y - ARRAYS THAT CONTAINS THE POINTS IN THE LINE                 *
' *  LSTDST - LAST DISTANCE CALCULATED                                 *
' *  NPTS - NUMBER OF POINTS IN THE LINE                               *
' *  PN - ARRAY OF POINTERS FOR POINTS TO BE USED IN CALCULATIONS      *
' *  PTCNT - INDEX FOR PROCESSING THROUGH LINE ARRAY                   *
' *  SQDIST - SQUARE DISTANCE THAT POINT IS FROM HYPOTHETICAL LINE     *
' *                                                                    *
' * ROUTINES CALLED:                                                   *
' *                                                                    *
' *  DISTSQ - CALCULATES THE SQUARE DISTANCE FROM A POINT TO A LINE    *
' *                                                                    *
' **********************************************************************
'
' CASE WHERE NO INTERVENING POINTS BETWEEN ANCHOR AND FLOATER
'
DIM PN%(3)
	IF ((FLOATR%-ANCHOR%) <= 1) THEN
		SQDIST = 0
'
' GENERAL CASE
'
	ELSE
		LSTDST = 0.0
		PN%(2) = ANCHOR%
		PN%(3) = FLOATR%
		FOR PTCNT%=ANCHOR%+1 TO FLOATR%-1
			PN%(1) = PTCNT%
			SQDIST = DISTSQ(X#(),Y#(),NPTS%,PN%())
			IF (SQDIST >= LSTDST) THEN
				LSTDST = SQDIST
				INDEX% = PTCNT%
			END IF
		NEXT PTCNT%
		SQDIST = LSTDST
	END IF
END SUB
